<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on December 1, 2008 at 8:12:40 am</time-stamp>
<!-- Package Changes for PV-CME-Core(Green.11,apikovsky)* -->


<methods>
<class-id>PROVISO.PvCmeEngine</class-id> <category>processing (post-hourly)</category>

<body package="PV-CME-Core" selector="flushInternal">flushInternal

	| stateTempHourDirectory outputStream delay outputHourDirectory |
	stateTempHourDirectory := 
		self fileInterface 
			getDirectoryForHourTimestamp: self currentHour
			relativeTo: self fileInterface stateTempDirectory.
	outputStream :=
		PvHourlyAggAndRawStreamSet 
			newForHourDirectory: stateTempHourDirectory
			hour: self currentHour asHours
			prefix: ''
			compressFiles: self compressOutputFiles
			fileInterface: self fileInterface.
	outputStream pvModel: self pvModel.
	self
		flushRawBucketsOn: outputStream;
		flushRaBucketsOn: outputStream;
		flushGaBucketsOn: outputStream.

	outputHourDirectory := 
		self fileInterface outputHourDirectoryForHourTimestamp: self currentHour.

	delay := 
		self fileInterface doStateChange: 
			[outputStream
				createFileLinksInDirectory: self fileInterface stateTempDirectory;
				close.
			"Delete any RA and GA files we don't want to present to LDR right now"
			self deleteAnyRAAndGAFilesBeforePresentingToLDR: stateTempHourDirectory forHour: self currentHour.
			(outputHourDirectory exists and: [outputHourDirectory directoryContents isEmpty])
				ifTrue: [outputHourDirectory delete].
			stateTempHourDirectory renameTo: outputHourDirectory.
			self fileInterface
				writeLastHourFileTimestamp: self currentHour;	
				moveBaselinesFromTempToState;
				moveStateTempToStateCurrent;
				writeCloseHourFileForTimestamp: self currentHour;
				moveFiles: self doneFiles toDoneHourDirectoryForTimestamp: self currentHour].
	self stats incrementTimingFor: #postHourlyFlowControlSeconds by: delay</body>
</methods>


</st-source>
